﻿Type=Class
Version=3.71
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private frm As Form		
	Private Msgbox As Msgboxes	
	Private AcntTV As TableView
	Private AddressEd As TextField
	Private NameEd As TextField
	Private PhoneEd As TextField	
	Private CostEd As TextField
'	Private ItemEd As TextField
	Private QtyEd As TextField
	Private SalesTV As TableView
	Private ItemsCmb As ComboBox
	Private AccountLbl As Label
	' Variables used
	Private AddressList As List		' used with Regex to seperate the Account Address for printing
	Private StockList As List		' used by the Items Combo - loads from Database Table (Stock)
	Private SalesList As List		' used for drawing the Stock Items for the Account
	Private ItemValue As String		' value of the ItemsCmb when selected
	Private AcntID As Int			' The ID for the Account Table used through the program
	Private InvNo As Int			' holds the Invoice No - obtained from the InvoiceNo Database Table (InvoiceNo)
	Private InvDate As String		' Holds the Date the Invoice is Made and used in AcntSummary as well
	Private AcntSummary As ACSUM	' UDT to hold the Invoice Details which are then used for the Account Summary
	Private Y_Axis As Float			' Value used for the Vertical positioning of Rules and Text in the PDF Doc
	Private TopDetails, BottomDetails As Float 	' Values used for the top and bottom of the Details Section in the PDF Doc
	Private PdfFileName As String
	' PDFjet Vars
	Private PDFjetConstants1 As PDFjetConstants
	Private PDFjetPDF1 As PDFjetPDF
	Dim PDFPage As PDFjetPage
	Dim PDFFont1 As PDFjetFont
	Dim PDFFont2 As PDFjetFont
	Dim PDFFont3 As PDFjetFont	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Parent As Form)
	frm.Initialize("frm", 600, 600)
	frm.SetFormStyle("UNIFIED")
'	frm.Resizable = False
	frm.RootPane.LoadLayout("AcntForm")	' Layout
	frm.SetOwner(Parent)
	frm.Stylesheets.Add(File.GetUri(File.DirAssets, "account.css"))
	SetUpAcntTV
	SetUpSalesTV
	LoadStockList
End Sub

Public Sub Show
	frm.Title = "Account Sales"	
	LoadAcntTable
	If AcntTV.Items.Size > 0 Then AcntTV.SelectedRow = 0
	frm.ShowAndWait	' Modal dialog
End Sub

Private Sub frm_Resize(Width As Double, Height As Double)
	frm.SetWindowSizeLimits(frm.WindowWidth, frm.WindowHeight, frm.WindowWidth, frm.WindowHeight)	
End Sub

' Load the Categories from the Categories Table into the Combobox
Private Sub LoadStockList
	Dim Qry1 As String
	Dim Cols() As String
	
	' Get Items from Stock Dbase into StockList
	' StockList is kept to refernce data in the List
	If StockList.IsInitialized Then StockList.Clear
	Qry1 = "SELECT * FROM Stock ORDER BY [Item]"
	StockList = DBUtils.ExecuteMemoryTable(DM.SQL1, Qry1, Null, 0)
	
	ItemsCmb.Items.Clear
	' Work through the list of Categories
	For i = 0 To StockList.Size - 1
		Cols = StockList.Get(i)
		ItemsCmb.Items.Add(Cols(1))
	Next
End Sub

' Checks that the entry for Cost is a decimal value
Sub CostEd_TextChanged (Old As String, New As String)
	Dim sb As StringBuilder
	sb.Initialize
	For i = 0 To New.Length - 1
	If "0123456789.".IndexOf(New.CharAt(i)) > -1 Then
		sb.Append(New.CharAt(i))
	End If
	Next
	CostEd.Text = sb.ToString
	CostEd.SetSelection(CostEd.Text.Length, CostEd.Text.Length)	
End Sub

' Checks that the value entered for Quantity is a number
Sub QtyEd_TextChanged (Old As String, New As String)
	Dim sb As StringBuilder
	sb.Initialize
	For i = 0 To New.Length - 1
	If "0123456789".IndexOf(New.CharAt(i)) > -1 Then
		sb.Append(New.CharAt(i))
	End If
	Next
	QtyEd.Text = sb.ToString
	QtyEd.SetSelection(QtyEd.Text.Length, QtyEd.Text.Length)	
End Sub

' Loads from the Acnt Table into the Account TableView (AcntTV)
Sub LoadAcntTable
	DBUtils.LoadTableView(DM.SQL1, "SELECT * FROM Acnt", Null, 0, AcntTV)
End Sub

' Loads from the Sales Table into the Sales TableView (SalesTV)
Sub LoadSalesTV
	DBUtils.LoadSalesTable(DM.SQL1, "SELECT SId, Date, Items, Cost, Quantity, Total FROM Sales WHERE MId = ? AND Inv IS NULL", Array As String(AcntID), 0, SalesTV)
End Sub

' Save Account Data to Acnt Table
Sub SaveBtn_Action
	Dim Idx As Int = 0
		
	If (NameEd.Text = "") Then
		Msgbox.DialogType = "ERROR"
		Msgbox.Show("Name Edit Box needs to be entered! ", "Field Entry Error")	
		NameEd.RequestFocus
		Return
	End If
	If (PhoneEd.Text = "") Then
		Msgbox.DialogType = "ERROR"
		Msgbox.Show("Phone Edit Box needs to be entered! ", "Field Entry Error")	
		PhoneEd.RequestFocus
		Return	
	End If
	If (AddressEd.Text = "") Then
		Msgbox.DialogType = "ERROR"
		Msgbox.Show("Address Edit Box needs to be entered! ", "Field Entry Error")	
		AddressEd.RequestFocus
		Return			
	End If		
	Try
		Dim M As Map
		M.Initialize
		M.Put("MId", Null)			
		M.Put("Name", NameEd.Text)
		M.Put("Phone", PhoneEd.Text)
		M.Put("Address", AddressEd.Text)
		
		DBUtils.InsertMaps(DM.SQL1, "Acnt", Array As Object(M))
		
		' Empty TextField Edit Boxes
		NameEd.Text = ""
		PhoneEd.Text = ""
		AddressEd.Text = ""
		
		' Re-load the Account Table View
		LoadAcntTable
		Idx = AcntTV.Items.Size - 1
		AcntTV.SelectedRow = Idx
		If Idx > 4 Then AcntTV.ScrollTo(Idx - 2)
	Catch
		Msgbox.DialogType = "ERROR"
		Msgbox.Show("Error Creating Account Entry! " & NameEd.Text, "Database Error")
		Log("No Account Record")
	End Try
End Sub

' Click on a Row in AcntTV
' Gets  AcntID
'		AccountLbl.text to display Account name above the Stock Items Section
'		Fills the AddressList to be used in the Address Box of the Invoice
' 		Loads the SalesTV for the Selected AcntTV 
Sub AcntTV_SelectedRowChanged(Index As Int, Row() As Object)
	Dim Str1 As String
	If Index <> -1 Then
		AcntID = Row(0)
		AccountLbl.Text = Row(1)
		Str1 = Row(3)
		
		If AddressList.IsInitialized Then 
			AddressList.Clear		
		Else
			AddressList.Initialize
		End If
		AddressList.AddAll(Regex.Split(",", Str1))

		LoadSalesTV
	Else
		AccountLbl.Text = ""
	End If
End Sub

' Select Item from the Stock item Combo
' and enters the Cost in the Cost Edit Control
Sub ItemsCmb_SelectedIndexChanged(Index As Int, Value As Object)
	ItemValue = Value
	Dim col() As String = StockList.Get(Index)
	CostEd.Text = NumberFormat2(col(2), 1, 2, 2, False)
End Sub

' Adds the Sales Stock Item to the Sales Table
' Reloads the SalesTV
Sub AddBtn_Action
'	If (ItemEd.Text = "") Then
	If ItemsCmb.SelectedIndex = -1 Then			
		Msgbox.DialogType = "ERROR"
		Msgbox.Show("Item ComboBox needs to be selected! ", "Field Select Error")	
		ItemsCmb.RequestFocus
		Return	
	End If
	If (CostEd.Text = "") Then
		Msgbox.DialogType = "ERROR"
		Msgbox.Show("Cost Edit Box needs to be entered! ", "Field Entry Error")	
		CostEd.RequestFocus
		Return	
	End If	
	If (QtyEd.Text = "") Then
		Msgbox.DialogType = "ERROR"
		Msgbox.Show("Quantity Edit Box needs to be entered! ", "Field Entry Error")	
		QtyEd.RequestFocus
		Return	
	End If
		
	Try
		DateTime.DateFormat = "dd/MM/yyyy"
		Dim M As Map
		M.Initialize
		M.Put("SId", Null)
		M.Put("MId", AcntID)
		M.Put("Date", DateTime.Date(DateTime.Now))
		M.Put("Items", ItemValue)
		M.Put("Cost", CostEd.Text)
		M.Put("Quantity", QtyEd.Text)
		M.Put("Total", Round2((CostEd.Text * QtyEd.Text), 2))
		
		DBUtils.InsertMaps(DM.SQL1, "Sales", Array As Object(M))
		
'		ItemsCmb.SelectedIndex = 0
'		CostEd.Text = ""
		QtyEd.Text = ""
		
		LoadSalesTV

	Catch
		Msgbox.DialogType = "ERROR"
		Msgbox.Show("Error Creating Sales Entry! " & CRLF & LastException, "Database Error")
		Log("No Item Record")
	End Try
End Sub

' Setup the AcntTV Columns
Sub SetUpAcntTV
	Dim RList As List
		
	RList.Initialize
	RList.Add("MId")			' MId
	RList.Add("Name")			' 
	RList.Add("Phone")			' 
	RList.Add("Address")		' 
	
	AcntTV.SetColumns(RList)
	
	AcntTV.SetColumnVisible(0, False) 	' MId
	AcntTV.SetColumnWidth(1, 150.01)	' Name
	AcntTV.SetColumnWidth(2, 97.01)		' Phone
	AcntTV.SetColumnWidth(3, 288.01)	' Address
		
	For i= 1 To 3
		AcntTV.SetColumnSortable(i, False)
	Next
	
	RList.Clear			
End Sub

' Setup the SalesTV columns
Sub SetUpSalesTV
	Dim RList As List
		
	RList.Initialize
	RList.Add("SId")			' SId
	RList.Add("Date")			' 
	RList.Add("Items")			' 
	RList.Add("Cost")		' 
	RList.Add("Qty.")		' 
	RList.Add("Total")		' 
	
	SalesTV.SetColumns(RList)
	
	SalesTV.SetColumnVisible(0, False) 	' SId
	SalesTV.SetColumnWidth(1, 100.01)	' Date
	SalesTV.SetColumnWidth(2, 215.01)	' Items
	SalesTV.SetColumnWidth(3, 70.01)	' Cost
	SalesTV.SetColumnWidth(4, 60.01)	' Qty
	SalesTV.SetColumnWidth(5, 89.01)	' Total
		
	For i= 1 To 5
		SalesTV.SetColumnSortable(i, False)
	Next
	
	RList.Clear			
End Sub

' =================================================INVOICE ============================================

' Begins the Invoicing Process into a PDF File
Sub InvoiceBtn_Action
	' Check that there are Stock items to be Invoiced
	If SalesTV.Items.Size > 0 Then	
		' Obtain an Invoice Number for this Invoice
		GetInvNo
		
		' Create the PDF
		CreatePDFTable
		
		' After Invice is done ...
		' Transfer Sales to Inv = 'Y' 
		Dim M As Map
		M.Initialize
		M.Put("Inv", "Y")
		DBUtils.UpdateRecord2(DM.SQL1, "Sales", M, CreateMap("MId":AcntID))
		M.Clear
		
		' Set AccountSummary Table with the Invoice no etc.
		Dim AC As Map
		AC.Initialize
		AC.Put("Id", Null)
		AC.Put("AcntID", AcntSummary.AcntID)
		AC.Put("InvNo", AcntSummary.InvNo)
		AC.Put("SDate", AcntSummary.SDate)
		AC.Put("SubTotal", AcntSummary.SubTotal)
		AC.Put("Tax", AcntSummary.Tax)
		AC.Put("Total", AcntSummary.Total)
		
		DBUtils.InsertMaps(DM.SQL1, "AcntSmry", Array As Object(AC))
		AC.Clear
		
		' Reload the SalesTV - Note the Sales will not appear for the Account just Invocied as they have been Transfered
		' after invoicing was completed
		
		LoadSalesTV
	Else
		Msgbox.DialogType = "ERROR"
		Msgbox.Show("No Stock Items have been entered!" & CRLF & $"${AccountLbl.Text}"$, "Field Entry Error")			
	End If
End Sub

' Obtains an Invoice Number
Sub GetInvNo
	Dim NewInvNo As Int
	
	Dim cur As ResultSet
	cur = DM.SQL1.ExecQuery("SELECT * FROM InvoiceNo")
	If cur.NextRow Then
		InvNo = cur.GetInt("InvNo")
		NewInvNo = InvNo + 1
		DBUtils.UpdateRecord(DM.SQL1, "InvoiceNo", "InvNo", NewInvNo, CreateMap("InvNo":InvNo))
	End If
	cur.Close
End Sub

' Setup the base of the PDF Doc
Sub CreateBasePDFDocument As PDFjetPDF
	Dim PDFDestination As OutputStream
	Dim str1 As String
	
	'Set Pdf File to Account Name
	str1 = AccountLbl.Text
	str1 = str1.Replace(" ", "_")
	PdfFileName = str1 & ".pdf"
	
	PDFDestination = File.OpenOutput(DM.ExcelFilePath, PdfFileName, False)
	
	PDFjetPDF1.Initialize("PDFjetPDF1", PDFDestination)
	PDFjetPDF1.SetAuthor("Black Jack")
	PDFjetPDF1.SetSubject("BPak Produce Merchant")
	PDFjetPDF1.SetTitle("Invoice")

	Return PDFjetPDF1
End Sub

' Main Sub to do the processing of the Drawing into the PDF Doc
Sub CreatePDFTable
	Dim PDFjetPDF1 As PDFjetPDF = CreateBasePDFDocument

	SetPageParams	
	
	Y_Axis = 140
	SetDocumentLayout
	
	Y_Axis = 30
	SetDocumentTitle
	
	' Do the Account here...
	Y_Axis = 150	
	DrawAccountAddress
	
	' Do Stock item Details here...
	DrawStockItems
	
	DrawItemTotals	
	
	PDFjetPDF1.Close
End Sub

' Sets the PDF Page Size, and Fonts needed
Sub SetPageParams
	PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)
	
	PDFFont1.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.HELVETICA_BOLD)
	PDFFont1.SetSize(9)

	PDFFont2.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.HELVETICA)
	PDFFont2.SetSize(9)
	
	PDFFont3.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.TIMES_BOLD)
	PDFFont3.SetSize(30)
	
End Sub

' Create the Basic layout of the Invoice (Rules and Standing Text lines
Sub SetDocumentLayout
	Dim PDFBox As PDFjetBox
	Dim HorLine As PDFjetLine
	Dim VertLine As PDFjetLine
	
	' Address Box
	PDFBox.Initialize2(72.0, Y_Axis, 224.0, 78.0)
	PDFBox.SetColor(PDFjetConstants1.Color.lightgray)
	PDFBox.DrawOn(PDFPage)
	
	' top Horiz Line of Details area
	TopDetails = Y_Axis + 96.0
	HorLine.Initialize(30.0, TopDetails, 572.0, TopDetails)
	HorLine.DrawOn(PDFPage)
	
	' Date text
	PDFFont1.SetSize(9)	
	DrawTextItem(PDFFont1, 30, TopDetails + 3.0, 70.0, 12, "Date", PDFjetConstants1.Color.black, PDFjetConstants1.Align.CENTER)
	' Item Text
	DrawTextItem(PDFFont1, 100, TopDetails + 3.0, 260.0, 12, "Stock Item", PDFjetConstants1.Color.black, PDFjetConstants1.Align.CENTER)
	' Unit Cost
	DrawTextItem(PDFFont1, 360, TopDetails + 3.0, 70.0, 12, "Unit Cost", PDFjetConstants1.Color.black, PDFjetConstants1.Align.CENTER)
	' Quantity
	DrawTextItem(PDFFont1, 430, TopDetails + 3.0, 70.0, 12, "Quantity", PDFjetConstants1.Color.black, PDFjetConstants1.Align.CENTER)
	' Total
	DrawTextItem(PDFFont1, 500, TopDetails + 3.0, 72.0, 12, "Total Cost", PDFjetConstants1.Color.black, PDFjetConstants1.Align.CENTER)
	
	' Line under Details Heading
	HorLine.Initialize(30.0, TopDetails + 18.0, 572.0, TopDetails + 18.0)
	HorLine.DrawOn(PDFPage)
	
	' Horiz Line at bottom of Details
	BottomDetails = 756.0
	HorLine.Initialize(30.0, BottomDetails, 572.0, BottomDetails)
	HorLine.DrawOn(PDFPage)
	
	' Sub Total Text
	DrawTextItem(PDFFont1, 405, BottomDetails + 3.5, 90.0, 12, "Sub Total  $", PDFjetConstants1.Color.black, PDFjetConstants1.Align.RIGHT)

	' Horiz Line Bottom of Sub Total $
	HorLine.Initialize(500.0, BottomDetails + 18.0, 572.0, BottomDetails + 18.0)
	HorLine.DrawOn(PDFPage)
	
	' Tax % Text
	DrawTextItem(PDFFont1, 405, BottomDetails + 21.5, 90.0, 12, "Tax 10%  $", PDFjetConstants1.Color.black, PDFjetConstants1.Align.RIGHT)

	' Horiz Line Bottom of TAX %
	HorLine.Initialize(500.0, BottomDetails + 36.0, 572.0, BottomDetails + 36.0)
	HorLine.DrawOn(PDFPage)
	
	' Total Amount
	DrawTextItem(PDFFont1, 405, BottomDetails + 39.5, 90.0, 12, "TOTAL  $", PDFjetConstants1.Color.black, PDFjetConstants1.Align.RIGHT)
	
	' Horiz Line Bottom of TOTAL $
	HorLine.Initialize(500.0, BottomDetails + 54.0, 572.0, BottomDetails + 54.0)
	HorLine.DrawOn(PDFPage)
	
	' vertical details lines
	' After Date
	VertLine.Initialize(100.0, TopDetails, 100.0, BottomDetails)
	VertLine.DrawOn(PDFPage)
	' After Stock Items
	VertLine.Initialize(360.0, TopDetails, 360.0, BottomDetails)
	VertLine.DrawOn(PDFPage)
	' After Unit Cost
	VertLine.Initialize(430.0, TopDetails, 430.0, BottomDetails)
	VertLine.DrawOn(PDFPage)
	' After Quantity
	VertLine.Initialize(500.0, TopDetails, 500.0, BottomDetails + 54.0)
	VertLine.DrawOn(PDFPage)
	
	' E. & O.E.
	PDFFont2.SetSize(7)
	DrawTextItem(PDFFont2, 30, BottomDetails + 42.0, 90.0, 12, "E.&O.E.", PDFjetConstants1.Color.black, PDFjetConstants1.Align.LEFT)
End Sub

' Creates Our Info at head of Invoice
Sub SetDocumentTitle
	PDFFont3.SetSize(26)
	DrawTextItem(PDFFont3, 30, Y_Axis, 542, 36, "BPak Produce Merchants", PDFjetConstants1.Color.crimson, PDFjetConstants1.Align.CENTER)
	PDFFont2.SetSize(12)	
	DrawTextItem(PDFFont2, 30, Y_Axis + 36, 542, 20, "116 The Esplanade, Brighton South,", PDFjetConstants1.Color.black, PDFjetConstants1.Align.CENTER)
	DrawTextItem(PDFFont2, 30, Y_Axis + 56, 542, 20, "State of Victoria - Area Code: 21198", PDFjetConstants1.Color.black, PDFjetConstants1.Align.CENTER)
	DrawTextItem(PDFFont2, 30, Y_Axis + 76, 542, 20, "Email: bpakproduce@gaagle.com       Telephone: 3494 341 783", PDFjetConstants1.Color.black, PDFjetConstants1.Align.CENTER)
	Y_Axis = 150
	DateTime.DateFormat = "dd/MM/yyyy"   ' NOTE: not USA date format
	InvDate = DateTime.Date(DateTime.Now)
	DrawTextItem(PDFFont2, 360, Y_Axis, 120, 20, $"Date: ${InvDate}"$, PDFjetConstants1.Color.black, PDFjetConstants1.Align.LEFT)
	PDFFont1.SetSize(14)
	DrawTextItem(PDFFont1, 360, Y_Axis+36, 80, 20, "Invoice No:", PDFjetConstants1.Color.black, PDFjetConstants1.Align.LEFT)
	DrawTextItem(PDFFont1, 440, Y_Axis+36, 90, 20, $"${InvNo}"$, PDFjetConstants1.Color.black, PDFjetConstants1.Align.LEFT)
End Sub

' Enters Clients Address into the Address Box area
Sub DrawAccountAddress
	Dim Str1 As String
	
	PDFFont2.SetSize(10)
	DrawTextItem(PDFFont2, 80, Y_Axis, 220, 20, $"${AccountLbl.text}"$, PDFjetConstants1.Color.black, PDFjetConstants1.Align.LEFT)
	For i = 0 To AddressList.Size-1
		Str1 = AddressList.Get(i)
		Str1 = Str1.Trim
		Y_Axis = Y_Axis + 12
		DrawTextItem(PDFFont2, 80, Y_Axis, 220, 20, $"${Str1}"$, PDFjetConstants1.Color.black, PDFjetConstants1.Align.LEFT)
	Next
End Sub

' Draw all the SalesTV items into the body of the Invoice
' Collects Data for Account Summary
Sub DrawStockItems
	Dim Qry1 As String
	Dim TotalCost As Double = 0.00
	
	TopDetails = TopDetails + 24
		
	PDFFont2.SetSize(10)
	Qry1 = $"
	SELECT SId, Date, Items, Cost, Quantity, Total 
	FROM Sales 
	WHERE MId = ? AND Inv IS NULL
	"$
	SalesList = DBUtils.ExecuteMemoryTable(DM.SQL1, Qry1, Array As String(AcntID), 0)
	
	For i = 0 To SalesList.Size - 1
		Dim Row() As String
		Row = SalesList.Get(i)
		
		DrawTextItem(PDFFont2,  30, TopDetails,  70, 13, $"${Row(1)}"$, PDFjetConstants1.Color.black, PDFjetConstants1.Align.CENTER)
		DrawTextItem(PDFFont2, 110, TopDetails, 240, 13, $"${Row(2)}"$, PDFjetConstants1.Color.black, PDFjetConstants1.Align.LEFT)
		DrawTextItem(PDFFont2, 360, TopDetails,  50, 13, $"${NumberFormat2(Row(3), 1, 2, 2, False)}"$, PDFjetConstants1.Color.black, PDFjetConstants1.Align.RIGHT)
		DrawTextItem(PDFFont2, 430, TopDetails,  50, 13, $"${Row(4)}"$, PDFjetConstants1.Color.black, PDFjetConstants1.Align.RIGHT)
		DrawTextItem(PDFFont2, 500, TopDetails,  65, 13, $"${NumberFormat2(Row(5), 1, 2, 2, False)}"$, PDFjetConstants1.Color.black, PDFjetConstants1.Align.RIGHT)

'		Qtys = Qtys + Row(4)
		TotalCost = TotalCost + Row(5)
		
		TopDetails = TopDetails + 14
	Next
	
	' Collect data for the SubTotal, Tax and Total; and for the Print AccountSumary on the Front window
	AcntSummary.Initialize
	
	AcntSummary.AcntID = AcntID
	AcntSummary.InvNo = InvNo
	AcntSummary.SubTotal = TotalCost
	AcntSummary.Tax = TotalCost * 0.10
	AcntSummary.Total = TotalCost + AcntSummary.Tax
	AcntSummary.SDate = InvDate
	
End Sub

' Draw the Sub-Total, Tax, Total - obtained from the AcntSummary UDT
Sub DrawItemTotals
	PDFFont2.SetSize(9)	
	DrawTextItem(PDFFont2, 500, BottomDetails + 3.5, 65.0, 13, $"${NumberFormat2(AcntSummary.SubTotal, 1, 2, 2, False)}"$, PDFjetConstants1.Color.black, PDFjetConstants1.Align.RIGHT)
	DrawTextItem(PDFFont2, 500, BottomDetails + 21.5, 65.0, 13, $"${NumberFormat2(AcntSummary.Tax, 1, 2, 2, False)}"$, PDFjetConstants1.Color.black, PDFjetConstants1.Align.RIGHT)
	DrawTextItem(PDFFont2, 500, BottomDetails + 39.5, 65.0, 13, $"${NumberFormat2(AcntSummary.Total, 1, 2, 2, False)}"$, PDFjetConstants1.Color.black, PDFjetConstants1.Align.RIGHT)

End Sub

' This Sub is used to Draw all the TEXT from all the other Subs
Sub DrawTextItem(PDFFont As PDFjetFont, LPos As Int, VPos As Int, Width As Int, Height As Int, Str1 As String, clr As Int, aln As Int)	
	Dim PDFTextBox As PDFjetTextBox
	PDFTextBox.Initialize(PDFFont)
	PDFTextBox.SetPosition(LPos, VPos)
	PDFTextBox.SetWidth(Width)
	PDFTextBox.SetHeight(Height)
	PDFTextBox.SetText(Str1)
	PDFTextBox.SetFgColor(clr)
	PDFTextBox.SetTextAlignment(aln)
	PDFTextBox.SetNoBorders					' comment out to see Draw Boxes for containing text

	PDFTextBox.DrawOn(PDFPage)	
End Sub	

' Display the Generated PDF Page/s - Print option is then accessible from the PDF Doc
Sub PDFjetPDF1_CloseComplete(Success As Boolean)
	If Success Then
		fx.ShowExternalDocument(File.GetUri(DM.ExcelFilePath, PdfFileName))
	Else
		Log("An error has occurred and creation of the PDF document has failed")
	End If
End Sub




