﻿Type=StaticCode
Version=3.71
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Public SQL1 As SQL
	Public CurOS As Int
	Public InitialFilePath As String
	Public DBaseFilePath As String		' Database Location
	Public ExcelFilePath As String		' Excel and Pdf File Location
End Sub

Public Sub CreateSqlDatabase
'	ObtainOSes
	ObtainFilePath

	' In it SQLite
	SQL1.InitializeSQLite(DBaseFilePath, "mydb.db", True)
End Sub

' Windows
' PMerch is Folder Name to contain Database (data) and Excel, Pdf (excel) files
Private Sub ObtainFilePath
	Dim str1 As String
	
	str1 = GetSystemProperty("user.home","")
	If Not(File.IsDirectory(str1, "PMerch")) Then
		File.MakeDir(str1, "PMerch")
		InitialFilePath = File.Combine(str1, "PMerch")
	Else
		InitialFilePath = File.Combine(str1, "PMerch")		
	End If
	
	' DBase File Path
	If Not(File.IsDirectory(InitialFilePath, "data")) Then
		File.MakeDir(InitialFilePath, "data")
		DBaseFilePath = File.Combine(InitialFilePath, "data")
	Else
		DBaseFilePath = File.Combine(InitialFilePath, "data")		
	End If
	
	' Excel File Path
	If Not(File.IsDirectory(InitialFilePath, "excel")) Then
		File.MakeDir(InitialFilePath, "excel")
		ExcelFilePath = File.Combine(InitialFilePath, "excel")
	Else
		ExcelFilePath = File.Combine(InitialFilePath, "excel")		
	End If	
End Sub

'Private Sub ObtainOSes
'	Dim os As String = GetSystemProperty("os.name", "").ToLowerCase
'	Log(os)
'	If os.Contains("win") Then
'		CurOS = 1
'	Else If os.Contains("mac") Then
'		CurOS = 2
'	Else
'		' Linux
'	    CurOS = 3
'	End If	
'End Sub

Public Sub CreateMyTables
	CreateAccount
'	DBUtils.DropTable(SQL1, "Sales")	
	CreateSales
	CreateStock
	CreateInvoiceNumber
	CreateAcntSummary
End Sub

' Creates an Account Table for all the Accounts (Clients)
Private Sub CreateAccount
	Dim sb As StringBuilder
	sb.Initialize	
	sb.Append("CREATE TABLE IF NOT EXISTS [Acnt] (")
	sb.Append("[MId] INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, ")
	sb.Append("[Name] CHAR(22) NOT NULL, ")
	sb.Append("[Phone] CHAR(12), ")
	sb.Append("[Address] CHAR(30), ")
	sb.Append("CONSTRAINT [acnt_sale] UNIQUE([Name]))")
	
	SQL1.ExecNonQuery(sb.ToString())  
End Sub

' Create Sales Table which holds a Clients Orders to be Invoiced
Private Sub CreateSales
	Dim sb As StringBuilder
	sb.Initialize	
	sb.Append("CREATE TABLE IF NOT EXISTS [Sales] (")
	sb.Append("[SId] INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, ")
	sb.Append("[MId] INTEGER, ")
	sb.Append("[Date] CHAR(12), ")
	sb.Append("[Items] CHAR(20), ")
	sb.Append("[Cost] FLOAT(5,2), ")
	sb.Append("[Quantity] INTEGER, ")
	sb.Append("[Total] FLOAT(7,2), ")
	sb.Append("[Inv] CHAR(1) )")

	SQL1.ExecNonQuery(sb.ToString()) 
End Sub

' Creates Stock Table for all Stock Items Sold along with their Current Cost
Private Sub CreateStock
	Dim sb As StringBuilder
	sb.Initialize	
	sb.Append("CREATE TABLE IF NOT EXISTS [Stock] (")
	sb.Append("[AId] INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, ")
	sb.Append("[Item] CHAR(35) NOT NULL, ")
	sb.Append("[Cost] FLOAT(5,2), ")
	sb.Append("CONSTRAINT [stk_itm] UNIQUE([Item]))")
	
	SQL1.ExecNonQuery(sb.ToString())  
End Sub

' Creates the Invocie Number Generator Table
Private Sub CreateInvoiceNumber
	Dim Qry1 As String
	
	Qry1 = $"
	CREATE TABLE IF NOT EXISTS [InvoiceNo] (
	[Id] INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, 
	[InvNo] INTEGER )
	"$
	SQL1.ExecNonQuery(Qry1)
	
	Dim cur As ResultSet
	cur = SQL1.ExecQuery("SELECT * FROM InvoiceNo")
	If cur.NextRow = False Then
		Dim M As Map
		M.Initialize
		M.Put("InvNo", 1)
		DBUtils.InsertMaps(SQL1, "InvoiceNo", Array As Object(M))
	End If
	cur.Close
End Sub

' Creates the Account Summary Table
Public Sub CreateAcntSummary
	Dim Qry1 As String
	
	Qry1 = $"
	CREATE TABLE IF NOT EXISTS [AcntSmry] (
	[Id] INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, 
	[AcntID] INTEGER,
	[InvNo] INTEGER,
	[SDate] CHAR(14),
	[SubTotal] FLOAT(7,2),
	[Tax] FLOAT(5,2),
	[Total] FLOAT(7,2) )
	"$
	SQL1.ExecNonQuery(Qry1)
End Sub





